//+------------------------------------------------------------------+
//|                                                        .mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#include <stderror.mqh>
#include <stdlib.mqh>
//---------------------
extern int ExtDepth = 21;//12;
extern int ExtDeviation = 13;//5;
extern int ExtBackstep = 34;//3;
extern double lots = 0.1;
extern int dk = 2;
extern bool tral = true;
extern bool bTrlinloss = true;
extern bool Tprofit = true;
extern bool coment = true;
extern bool pips = true;
extern bool sound = true;
//-----------------------
static int prevtime = 0 ;
static int prevbars = 0 ;
static datetime sdtPrevtime = 0;
double prise,prise1,prise2,prise1ontr,prise2ontr,Fibo;
bool apcontr=false;
int iTicket,iTmFrme,magic;
int LastTicket = 0;
bool trade,tr764=false,tr618=false,tr500=false,tr382=false,tr234=false;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//--------------  ----------------------------------------------------- 
prise2 = iCustom(NULL,0,"YraZFibo",ExtDepth,ExtDeviation,ExtBackstep,2,1); // 100%
prise1 = iCustom(NULL,0,"YraZFibo",ExtDepth,ExtDeviation,ExtBackstep,2,2); // 0.0%
//------------------------------MALKD------------------------------------------------------
double makd1 = iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_MAIN,1);
double makd2 = iMACD(NULL,0,5,34,5,PRICE_CLOSE,MODE_SIGNAL,1);
if ((makd1<0&&makd2<0)&&(makd2>makd1)){string makd ="DN";}
//--------------   ---------------------------------------
double marktwide = ((MathAbs(prise1- prise2))/8)/Point;         //   
double spread = MarketInfo(Symbol(),MODE_SPREAD);
double stop = MarketInfo(Symbol(),MODE_STOPLEVEL);
double minwide = (spread+stop);                                 //   
bool ap;                                                        //   
if (prise1<prise2){ ap = true;}
if (prise1>prise2){ap = false;}
//--- . .---..bool inside;double FiboRate----+
//--- -----
double min,max;
double FiboRate,FiboPrise1,FiboPrise2;
bool inside;
//---------------------------------------------------------+
RefreshRates();
double medianprise = NormalizeDouble(((MarketInfo(Symbol(),MODE_BID))+(spread/2)*Point),Digits);        
double interval = NormalizeDouble(((spread + stop)*Point),Digits);
if (prise1>prise2){ min = prise2; max = prise1;}else{min = prise1;max = prise2;}
double Fibowide = (max- min)/Point;
double FoolFibowide = Fibowide*1.618;
double FiboMedianPrise = (min+((max-min)/2));
//---    --------------------------+
if ((medianprise < (min-interval))||(medianprise > (max+interval)))
      {inside = false;string ins = " !!!";}else{inside = true;ins = "  ";}//     

//---       
if (medianprise >= min)
   {
   for (int n=0;n<FoolFibowide;n++)
       {
       double m = (min+(n*Point));
       if (medianprise == m)
          {
          FiboRate=(n/(Fibowide/100));// .  0  161%
          if (FiboRate != 0){Fibo =FiboRate;}
          break;
          }
       }   
    }
if (medianprise < min) //  
    {    
    double _Fibowide=(Fibowide*0.618);
    for (int mx=0;mx<_Fibowide;mx++)
        {
        double mxx = (min-(mx*Point));
        if (medianprise == mxx)
           {
           FiboRate=(mx/(_Fibowide/100))*(-1);
           if (FiboRate <= 0){Fibo = FiboRate;}
           }
        }
     } 
//------------------------------------------------------------------+
bool FiboAp = false;
bool FiboDn = false;
if(Fibo>=92&&Fibo<=105){FiboAp=true;FiboDn=false;}
if(Fibo<=10&&Fibo>=0){FiboDn=true;FiboAp=false;}
Comment(Fibo+"   "+Fibowide+"  "+trade+"  "+makd);
//------------------------------------------------------------------+

int ticket,err;
double pr,sl,tp;
int total=OrdersTotal();
if(total>0)
 {
  OrderSelect(0,SELECT_BY_POS,MODE_TRADES);
  if(OrderSymbol()==Symbol())
  {
  ticket=OrderTicket();
   if((OrderProfit()<(Fibowide/3))&&((Minute()==5)||(Minute()==10)||(Minute()==15)||(Minute()==20)
      ||(Minute()==25)||(Minute()==30)||(Minute()==35)||(Minute()==40)||(Minute()==45)||(Minute()==50)||(Minute()==55)
       &&(Seconds()<=3))) 
   {
   
     if(OrderProfit()<0)
      {
      if(OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice(),OrderStopLoss()+1*Point,OrderTakeProfit(),Green);Sleep(70000);}
      if(OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice(),OrderStopLoss()-3*Point,OrderTakeProfit(),Green);Sleep(70000);}  
              
      }
      else
       {
       if(OrderType()==OP_BUY){ModifyOrder(OrderOpenPrice(),OrderStopLoss()+1*Point,OrderTakeProfit(),Green);Sleep(70000);}
       if(OrderType()==OP_SELL){ModifyOrder(OrderOpenPrice(),OrderStopLoss()-3*Point,OrderTakeProfit(),Green);Sleep(70000);}   
         
       }
    }
   
   }
  } 


//------------------------------  ----------------------------------+
if(Fibo>=90){bool konn=true;}
total=OrdersTotal();
if(total<1 && Fibowide>66 && trade==false && konn==true)
 {
 tr764=false;tr618=false;tr500=false;tr382=false;tr234=false;
  RefreshRates();
   if(Fibo <=90 && Fibo >= 87)
    {
     pr = Ask;
      sl = NormalizeDouble((min+(Fibowide*1.27*Point)),Digits);
       if (Tprofit){tp = NormalizeDouble((min+(Fibowide*0.50*Point)),Digits);}else{tp =0;}//SELL
        Print("2.1 ",Fibo,"  ",pr,"  ",sl,"  ",tp,"  ",magic);    
          ticket=OrderSend(Symbol(),OP_SELL,lots,Ask,3,sl,tp,0,887,0,Red);
           if(ticket>0){trade = true;konn=false;}else{trade = false;}
           Print(ticket,"trade",trade);
            }
             }
total=OrdersTotal();
if(total<1&&Fibowide>50&&trade==false)  
   {          
   if(Fibo <=127 && Fibo >= 123)
    {
     pr = Bid;
      sl = NormalizeDouble((min+(Fibowide*0.887*Point)),Digits);
       if (Tprofit){tp = NormalizeDouble((min+(Fibowide*1.5*Point)),Digits);}else{tp =0;}//BUY
         Print("2.2 ",Fibo,"  ",pr,"  ",sl,"  ",tp,"  ",magic);    
          ticket=OrderSend(Symbol(),OP_BUY,lots,Bid,3,sl,tp,0,127,0,Blue);
           if(ticket>0){trade = true;}else{trade = false;}
            }            
             }
total=OrdersTotal();
if(total<1&&Fibowide>50&&trade==false)
 {
  RefreshRates();
   if(Fibo <=-11 )
    {
     pr = Ask;
      sl = NormalizeDouble((min+(Fibowide*0.236*Point)),Digits);
       if (Tprofit){tp = NormalizeDouble((min-(Fibowide*0.27*Point)),Digits);}else{tp =0;}//SELL
         Print("2.3 ",Fibo,"  ",pr,"  ",sl,"  ",tp,"  ",magic);    
          ticket=OrderSend(Symbol(),OP_SELL,lots,Ask,3,sl,tp,0,-115,0,Red);
           if(ticket>0){trade = true;}else{trade = false;}
            }
             }
total=OrdersTotal();
if(total<1&&Fibowide>66&&trade==false) 
 {           
          
   if(Fibo >=11 && Fibo <= 13)
    {
     RefreshRates(); 
      pr = Bid;
       sl = NormalizeDouble((min-(Fibowide*0.618*Point)),Digits);
        if (Tprofit){tp = NormalizeDouble((min+(Fibowide*0.50*Point)),Digits);}else{tp =0;}//SELL
         Print("2.4 ",Fibo,"  ",pr,"  ",sl,"  ",tp,"  ",magic);    
          ticket=OrderSend(Symbol(),OP_BUY,lots,Bid,3,sl,tp,0,115,0,Blue);
           if(ticket>0){trade = true;}else{trade = false;}
            }            
             }
  
 if (Time[0] == prevtime) return(0);
 prevtime = Time[0];
 trade=false;                      
 konn=false;  
  
  return(0);
  }
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++  
//--------  -----------------------------------
int ordrsend(bool tip,double prise,double sl,double tp,int magic)
{//tip = false => OP_BUYSTOP ; tip = true => OP_SELLSTOP;
   GetLastError();
   int err;
   double lastprise; //   
   int ticket;
   int slip =(MarketInfo(Symbol(),MODE_SPREAD))*Point;//  = 
//------   
   while (!IsTradeAllowed()){ Sleep(5000);}//      5 
   if (tip == false)
    {
     for(int i=0;i<5;i++) 
      {
       RefreshRates();//  
        ticket = OrderSend(Symbol(), OP_BUY,lots ,prise, slip,sl,tp,NULL,magic,0, Blue);
         if (ticket < 0)
          {
           if(sound){PlaySound("timeout.wav");}
            Print("  !",prise,"  ",sl,"  ",tp,"      BUY!");
             }
              else
               {
                break;
                 }
                  }
                   }
  if(tip==true)
   {
    for( i=0;i<5;i++) 
     {
      RefreshRates();//  
       ticket = OrderSend(Symbol(), OP_SELL, lots ,prise, slip,sl,tp,NULL,magic,0, Red);
        if (ticket < 0)
         {
          if(sound){PlaySound("timeout.wav");}
           Print("  !",prise,"  ",sl,"  ",tp,"      SELL!");
            }
             else
              {
               break;
                }
                 }
                  }

return(ticket);     
}  
//----------------  ----------------------------+    
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 28.11.2006                                                     |
//|   :     .           |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    pp -                                                 |
//|    sl -                                                 |
//|    tp -                                                 |
//|    cl -                                               |
//+----------------------------------------------------------------------------+
void ModifyOrder(double pp=-1, double sl=0, double tp=0, color cl=CLR_NONE) {
  bool   fm;
  double op, pa, pb, os, ot,st,oldsl;
  int    dg=MarketInfo(OrderSymbol(), MODE_DIGITS), er, it;
  int    NumberOfTry = 2;
 
  if (pp<=0) pp=OrderOpenPrice();
  if (sl<0 ) sl=OrderStopLoss();
  if (tp<0 ) tp=OrderTakeProfit();
  
  pp=NormalizeDouble(pp, dg);
  sl=NormalizeDouble(sl, dg);
  tp=NormalizeDouble(tp, dg);
  op=NormalizeDouble(OrderOpenPrice() , dg);
  os=NormalizeDouble(OrderStopLoss()  , dg);
  ot=NormalizeDouble(OrderTakeProfit(), dg);
  st=MarketInfo(OrderSymbol(), MODE_STOPLEVEL)*Point;
  if (pp!=op || sl!=os || tp!=ot) {
    for (it=1; it<=NumberOfTry; it++) {
      if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) break;
      while (!IsTradeAllowed()) Sleep(5000);
      RefreshRates();
      if(OrderType()==OP_BUY&& (sl>(Bid+st))){sl=NormalizeDouble(pb-(st*2),dg);}
      if(OrderType()==OP_SELL&& (sl<(Ask+st))){sl=NormalizeDouble(pa+(st*2),dg);}
      if(sl==os){break;}
      if(OrderType()==OP_SELL&& (sl>os)){break;}
      if(OrderType()==OP_BUY&& (sl<os)){break;}
      fm=OrderModify(OrderTicket(), pp, sl, tp, 0, cl);
      if (fm) {
        if (sound) PlaySound("ok.wav"); break;
      } else {
        er=GetLastError();
        pa=MarketInfo(OrderSymbol(), MODE_ASK);
        pb=MarketInfo(OrderSymbol(), MODE_BID);

        Print("Error(",er,") modifying order: ",ErrorDescription(er),", try ",it);
        Print("Ask=",pa,"  Bid=",pb,"  sy=",OrderSymbol(),
              "  op= Modify"+(OrderType()),"  pp=",pp,"  sl=",sl,"  tp=",tp);
        Sleep(1000*10);
      }
    }
  }
} 